# Import some stuff
import path, es, re
import lolpython # Just assume it's here, no try...except tests.

# Some addon info
info = es.AddonInfo()
info.author     = 'Ojii'
info.version    = 'CHEEZBURGER.CHEEZBURGER'
info.basename   = 'loles'
info.name       = 'LOLCODE EventScripts'

# Just for gameservers.com lookup
es.set("loles_version",info.version)
es.makepublic("loles_version")

# Some globals for later use
gamedir = path.path(str(es.ServerVar('eventscripts_gamedir')))
addonsdir = gamedir.joinpath('addons/eventscripts/')
mydir = addonsdir.joinpath('loles/')
cache = mydir.joinpath('cache/')

# Register some commands on loading
def load():
    es.regcmd('lol_load','loles/load_addon','Load LOLCODE addons')
    
# Command handler
def load_addon():
    if es.getargc() != 2:
        es.dbgmsg(0,"ROFLZ U PHAILD!!!! BTW lol_load <addonname>")
        return
    else:
        addon = es.getargv(1)
    if _checkAddon(addon):
        _parseAddon(addon)
        es.load('loles/cache/%s' % addon)
    else:
        es.dbgmsg(0,"O NOES!!! FILZORZ NOT THERE!!!")

# Make directory if not exists
def _mkdir(dirname):
    if not dirname.isdir():
        dirname.mkdir()
_mkdir(cache) # Make cache if it doesn't exist
initfile = cache.joinpath('__init__.py')
initfile.touch()

# Fix things like es.regcmd('myaddon/block',...)
def _fixNames(addon,pythoncode):
    content = pythoncode.text()
    newcontent,changed = repl(content,addon)
    if changed:
        pythoncode.write_text(newcontent)

def repl(content,addonname):
    found = False
    # general pattern to search for addon blocks in the code
    p = re.compile('''[(]\s*['"]\s*%s\s*/\s*\w*\s*['"]\s*,\s*['"]\s*\w*\s*['"]\s*[)]''' % addonname)
    # find all matches
    fa = p.findall(content)
    # pattern for single quotation strings
    ps = re.compile('''[(]\s*[']\s*%s\s*/\s*''' % addonname)
    # pattern for double quotation strings
    pd = re.compile('''[(]\s*["]\s*%s\s*/\s*''' % addonname)
    # iterate over the matches found
    for f in fa:
        # see if it's singel quote
        if ps.match(f):
            # replace
            content = content.replace(f,ps.sub("('loles/cache/%s/" % addonname, f, 1))
            found = True
        # else see if it's double quote
        elif pd.match(f):
            # replace
            content = content.replace(f,pd.sub('("loles/cache/%s/' % addonname, f, 1))
            found = True
    # and return
    return (content,found)

# Parse an addon into the cache for importing
def _parseAddon(addon):
    _mkdir(cache.joinpath('%s/' % addon))
    lolcode = addonsdir.joinpath('%s/%s.lol' % (addon,addon))
    lolmd5 = lolcode.read_md5()
    pythoncode = cache.joinpath('%s/%s.py' % (addon,addon))
    md5check = cache.joinpath('%s/.%s.md5' % (addon,addon))
    md5check.touch()
    # Only parse addon if neccessary
    if not pythoncode.isfile() or lolmd5 != md5check.text():
        lolpython.convert_file(lolcode.open('r'), pythoncode.open('w'))
        _fixNames(addon,pythoncode)
        md5check.write_text(lolmd5)

# Check addon file existance
def _checkAddon(addon):
    addondir = addonsdir.joinpath(addon)
    if not addondir.isdir():
        return False
    addonfile = addondir.joinpath('%s.lol' % addon)
    return addonfile.isfile()
